#!/usr/bin/env python

""" Example for analyse URIs and Host for detect Zeus Malware """

__author__ = "Luis Campo Giralte"
__copyright__ = "Copyright (C) 2013-2015 by Luis Campo Giralte"
__revision__ = "$Id$"
__version__ = "0.1"
import sys
import os
import base64
import glob
sys.path.append("../src/")
import pyaiengine

def callback_uri(flow):
    print("Zeus activity detected on flow",str(flow))

def callback_host(flow):
    h = flow.getHTTPInfo()
    if (h):
        host = str(h.hostname)
        if (host):
            print("Suspicious activity detected on flow",str(flow),host)

if __name__ == '__main__':

    st = pyaiengine.StackLan()

    data = dict()
    # Load the hosts and Urls on memory
    # The list have been download from https://zeustracker.abuse.ch/blocklist.php?download=compromised
    h_mng = pyaiengine.DomainNameManager()
    with open("zeus.dat") as f:
        for line in f.readlines():
            l = line.strip()
            b = l.find("/")
            r_host = l[:b]
            r_uri = l[b:]
            if (not data.has_key(r_host)):
                h = pyaiengine.DomainName(r_host,r_host)
                s = pyaiengine.HTTPUriSet("Set for %s" % r_host)

                h.callback = callback_host
                h_mng.addDomainName(h)
                h.setHTTPUriSet(s)

                s.callback = callback_uri
                data[r_host] = (h,s)
         
            data[r_host][1].addURI(r_uri)

    """ Plug the DomainNameManager on the HTTPProtocol """ 
    st.setDomainNameManager(h_mng,"HTTPProtocol")

    st.tcpflows = 500000
    st.udpflows = 163840

    with pyaiengine.PacketDispatcher("eth0") as pd:
        pd.stack = st
        pd.run()

    print h_mng

    sys.exit(0)

